// XText3Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "XText3.h"
#include "XText3Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define		REGOPT		"Software\\EWI\\XText3"
#define		BUFFERSIZE	1024

#define compGT(a, b)	(a > b)

//------------------------------------------------------------------

BOOL IsChar (unsigned char c, Opt *o);
BOOL IsRus (unsigned char c, Opt *o);
BOOL IsEng (unsigned char c, Opt *o);

//----------------------------------------------------------------------------------

int NFiles;					//   
CStringList OpenFiles;		//   
HANDLE event;				// 

void SetText();
void ToUpper (unsigned char *c, Opt o);
void Sort (CString *items, unsigned int nlines);
void Delete (CString *items, unsigned int nlines);
UINT Begin (LPVOID pParam);




//--------------------------------------------------------------------
class CAboutDlg : public CDialog 
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnMail();
	afx_msg void OnUrl();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_MAIL, OnMail)
	ON_BN_CLICKED(IDC_URL, OnUrl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXText3Dlg dialog

CXText3Dlg::CXText3Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXText3Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXText3Dlg)
	m_Lang = -1;
	m_Type = -1;
	m_Sort = FALSE;
	m_Del = FALSE;
	m_Cod = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CXText3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXText3Dlg)
	DDX_Control(pDX, IDC_SPIN, m_Spin);
	DDX_Radio(pDX, IDC_RADIO1, m_Lang);
	DDX_Radio(pDX, IDC_RADIO4, m_Type);
	DDX_Check(pDX, IDC_CHECK1, m_Sort);
	DDX_Check(pDX, IDC_CHECK2, m_Del);
	DDX_CBIndex(pDX, IDC_COD, m_Cod);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CXText3Dlg, CDialog)
	//{{AFX_MSG_MAP(CXText3Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_BROWSEIN, OnBrowsein)
	ON_BN_CLICKED(IDC_BROWSEOUT, OnBrowseout)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN, OnDeltaposSpin)
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_COD, OnSelchangeCod)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXText3Dlg message handlers

BOOL CXText3Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	GetDlgItem(IDC_START)->EnableWindow(FALSE);

	HKEY Key;
	BYTE temp;
	
	if (RegOpenKey (HKEY_CURRENT_USER, REGOPT, &Key) == ERROR_SUCCESS)
	{
		unsigned long size = sizeof(m_Lang);
		DWORD dwType = REG_BINARY;

		if (RegQueryValueEx(Key, 
							(LPCTSTR)"Language", 
							NULL, 
							&dwType, 
							(LPBYTE)&temp, 
							&size) != ERROR_SUCCESS)
					m_Lang = 0;
		else
			m_Lang = temp;

		if (RegQueryValueEx(Key, 
							(LPCTSTR)"Type", 
							NULL, 
							&dwType, 
							(LPBYTE)&temp, 
							&size) != ERROR_SUCCESS)
					m_Type = 0;
		else
			m_Type = temp;
		if (RegQueryValueEx(Key, 
							(LPCTSTR)"MinWord", 
							NULL, 
							&dwType, 
							(LPBYTE)&temp, 
							&size) != ERROR_SUCCESS)
					MinWord = 4;
		else
			MinWord = temp;
		if (RegQueryValueEx(Key, 
							(LPCTSTR)"Cod", 
							NULL, 
							&dwType, 
							(LPBYTE)&temp, 
							&size) != ERROR_SUCCESS)
					m_Cod = 0;
		else
			m_Cod = temp;
		
		if (RegQueryValueEx(Key, 
							(LPCTSTR)"Sort", 
							NULL, 
							&dwType, 
							(LPBYTE)&temp, 
							&size) != ERROR_SUCCESS)
					m_Sort = TRUE;
		else
			m_Sort = temp;		
		if (RegQueryValueEx(Key, 
							(LPCTSTR)"Delete", 
							NULL, 
							&dwType, 
							(LPBYTE)&temp, 
							&size) != ERROR_SUCCESS)
					m_Del = TRUE;
		else
			m_Del = temp;		
	RegCloseKey(Key);
	}
	else
	{
		m_Type = 0;
		MinWord = 4;
		m_Cod = 0;
		m_Sort = TRUE;
		m_Del = TRUE;
		m_Lang = 0;
	}
	m_Spin.SetPos(MinWord);
	SelIn = FALSE;
	SelOut = FALSE;
	UpdateData(FALSE);
	NFiles = 0;
	GetDlgItem(IDC_CHECK2)->EnableWindow(m_Sort);
	event = CreateEvent (0, 0, TRUE, 0);				//    

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CXText3Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if (nID == SC_CLOSE)
		return;
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CXText3Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CXText3Dlg::OnClose() 
{
	if (!NFiles)
		DestroyWindow();
}

void CXText3Dlg::OnBrowsein() 
{
	CFileDialog *fd = new CFileDialog(TRUE,
									  NULL,
									  NULL,
									  OFN_HIDEREADONLY | 
									  OFN_OVERWRITEPROMPT,
									  " |*.*||",
									  NULL);
	if (fd->DoModal() == IDOK)
	{
		if (OpenFiles.Find(InFile))
			OpenFiles.RemoveAt(OpenFiles.Find(InFile));
		InFile = fd->GetPathName();
		if (OpenFiles.Find(InFile))
		{
			AfxMessageBox ("     ");
		}
		else
		{
			SelIn = TRUE;
			OpenFiles.AddTail(InFile);
			GetDlgItem(IDC_INPUT)->SetWindowText(InFile);
			if (SelIn && SelOut)
				GetDlgItem(IDC_START)->EnableWindow(TRUE);
		}

	}

	delete fd;
}

void CXText3Dlg::OnBrowseout() 
{
	CString str;
	CFileDialog *fd = new CFileDialog(FALSE, NULL, NULL,
									  OFN_HIDEREADONLY | 
									  OFN_OVERWRITEPROMPT,
									  "|*.txt||",
									  NULL);
	if (fd->DoModal() == IDOK)
	{
		str = fd->GetPathName();
	}
	else
	{
		delete fd;
		return;
	}

	if (OpenFiles.Find(OutFile))
		OpenFiles.RemoveAt(OpenFiles.Find(OutFile));

	if (str.Find('.') == -1)
		str += ".txt";


	OutFile = str;
	if (OpenFiles.Find(OutFile))
	{
		AfxMessageBox ("     ");
	}
	else
	{

		OpenFiles.AddTail(OutFile);
		GetDlgItem(IDC_OUTPUT)->SetWindowText(OutFile);
		SelOut = TRUE;
		if (SelIn && SelOut)
			GetDlgItem(IDC_START)->EnableWindow(TRUE);
	}
	delete fd;
//	sFiles.outf = OutFile;
}

void CXText3Dlg::OnCheck1() 
{
	UpdateData(TRUE);
	if (m_Sort)
		GetDlgItem(IDC_CHECK2)->EnableWindow(TRUE);
	else
		GetDlgItem(IDC_CHECK2)->EnableWindow(FALSE);
}

void CXText3Dlg::OnCheck2() 
{
	UpdateData(TRUE);
}

void CXText3Dlg::OnRadio1() 
{
	UpdateData(TRUE);	
}

void CXText3Dlg::OnRadio2() 
{
	UpdateData(TRUE);	
}

void CXText3Dlg::OnRadio3() 
{
	UpdateData(TRUE);	
}

void CXText3Dlg::OnRadio4() 
{
	UpdateData(TRUE);	
}

void CXText3Dlg::OnRadio5() 
{
	UpdateData(TRUE);	
}

void CXText3Dlg::OnDeltaposSpin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

	m_Spin.SetPos(pNMUpDown->iPos - pNMUpDown->iDelta);
	MinWord = m_Spin.GetPos();
	*pResult = TRUE;
}

void CXText3Dlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	HKEY Key;
	if (RegCreateKey(HKEY_CURRENT_USER,
					REGOPT, &Key) == ERROR_SUCCESS)
	{
		RegSetValueEx(Key, "Language", 0, REG_BINARY, (BYTE*)&m_Lang,
						REG_SZ);
		RegSetValueEx(Key, "Type", 0, REG_BINARY, (BYTE*)&m_Type,
						REG_SZ);

		int temp = m_Spin.GetPos();

		RegSetValueEx(Key, "MinWord", 0, REG_BINARY, (BYTE*)&temp,
						REG_SZ);
		RegSetValueEx(Key, "Cod", 0, REG_BINARY, (BYTE*)&m_Cod,
						REG_SZ);
		RegSetValueEx(Key, "Sort", 0, REG_BINARY, (BYTE*)&m_Sort,
						REG_SZ);
		RegSetValueEx(Key, "Delete", 0, REG_BINARY, (BYTE*)&m_Del,
						REG_SZ);		
	}
	CloseHandle (event);
}


void CXText3Dlg::OnSelchangeCod() 
{
	UpdateData(TRUE);	
}

void CXText3Dlg::OnStart() 
{
	SelIn = SelOut = FALSE;

	GetDlgItem(IDC_INPUT)->SetWindowText("");
	GetDlgItem(IDC_OUTPUT)->SetWindowText("");
	GetDlgItem(IDC_START)->EnableWindow(FALSE);

	WaitForSingleObject (event, INFINITE);		// ,    

	sOpt.inf = InFile;
	sOpt.MinWord = MinWord;
	sOpt.outf = OutFile;
	sOpt.Cod = m_Cod;
	sOpt.Del = m_Del;
	sOpt.Lang = m_Lang;
	sOpt.Sort = m_Sort;
	sOpt.Type = m_Type;

	ResetEvent (event);		//   

	NFiles++;
	SetText();
	AfxBeginThread (Begin, (void *)&sOpt);
}

BOOL IsEng (unsigned char c, Opt *o)
{
	BOOL res = ((c >= 65 && c <= 90) || (c >= 97 && c <= 122));
	return res;
}

BOOL IsRus (unsigned char c, Opt *o)
{
	BOOL res;
	int Cod = o->Cod;

	switch (Cod)
	{
	case 0:						// DOS
		res = (c >= 128 && c <= 175) || (c >= 224 && c <= 241);
		break;
	case 1:						// Windows
		res = (c >= 192 && c <= 255);
		break;
	}
	return res;
}

BOOL IsChar (unsigned char c, Opt *o)
{
	int Lang;
	Lang = o->Lang;
	
	BOOL res;
	switch (Lang)
	{
	case 0:
		res = IsEng(c, o);
		break;
	case 1:
		res = IsRus(c, o);
		break;
	case 2:
		res = (IsEng(c, o) || IsRus (c, o));
		break;
	};
	return res;
}

void SetText ()
{
	if (!NFiles)
		AfxGetMainWnd()->SetWindowText("XText 3");
	else
	{
		CString str;
		str.GetBuffer(1024);
		str.Format ("  : %d", NFiles);
		AfxGetMainWnd()->SetWindowText(str);
		str.ReleaseBuffer();
	}
}

void ToUpper (unsigned char *c, Opt o)
{
	if ((*c) >= 97 && (*c) <= 122)
	{
		(*c) -= 32;
		return;
	}

	switch (o.Cod)
	{
	case 0:					// DOS
		if ((*c) >= 160 && (*c) <= 175)
		{
			(*c) -= 32;
		}
		if ((*c) >= 224 && *c <= 239)
			(*c) -= 80;
		if ((*c) == 241)
			(*c)--;
		break;
	case 1:					// Win
		if ((*c) >= 224 && (*c) <= 255)
			(*c) -= 32;
		break;
	}
}

void Sort (CString *a, int lb, int ub)
{
/*	unsigned long i, j;
	for (i = 0; i < nlines - 1 && nlines > 1; i++)
	{
		unsigned long k = i;
		CString x = items[i];
		for(j = i+1; j < nlines; j++)
			if (items[j] < x)
			{
				k = j;
				x = items[k];
			}
			items[k] = items[i];
			items[i] = x;
	}*/
    int n, h, i, j;
    CString t;

   /**************************
    *  sort array a[lb..ub]  *
    **************************/

    /* compute largest increment */
    n = ub - lb + 1;
    h = 1;
    if (n < 14)
        h = 1;
    else if (sizeof(int) == 2 && n > 29524)
        h = 3280;
    else {
        while (h < n) h = 3*h + 1;
        h /= 3;
        h /= 3;
    }

    while (h > 0) {

        /* sort-by-insertion in increments of h */
        for (i = lb + h; i <= ub; i++) {
            t = a[i];
            for (j = i-h; j >= lb && compGT(a[j], t); j -= h)
                a[j+h] = a[j];
            a[j+h] = t;
        }

        /* compute next increment */
        h /= 3;
    }

}

void Delete (CString *items, unsigned int nlines)
{
	unsigned int n, j;
	for (j = 0; j < nlines; j++)
	{
		if ((j+1) < nlines && items[j+1] == items[j])
		{
			n = 1;
			for (; (j+n) < nlines && items[j] == items[j+n]; n++)
				items[j+n].Empty();
			j += (n-1);
		}
	}
}

UINT Begin (LPVOID pParam)
{
	CFile In, Out;
	unsigned char *buf = new unsigned char [BUFFERSIZE];
	unsigned char *oldbuf = new unsigned char [BUFFERSIZE];
	Opt Option;
	UINT nlines = 1;						//   

	Option.inf = ((Opt*)pParam)->inf;
	Option.Cod = ((Opt*)pParam)->Cod;
	Option.Del = ((Opt*)pParam)->Del;
	Option.Lang = ((Opt*)pParam)->Lang;
	Option.MinWord = ((Opt*)pParam)->MinWord;
	Option.outf = ((Opt*)pParam)->outf;
	Option.Sort = ((Opt*)pParam)->Sort;
	Option.Type = ((Opt*)pParam)->Type;
	SetEvent(event);						//  

	UINT Read;
//	BOOL first = TRUE;
	unsigned long i, j;
	BOOL EndStr = TRUE;		//     ?
	int StrLen = 0;				//   
	char EndLine[2] = {'\r', '\n'};

	if (!In.Open(Option.inf, CFile::modeRead))
	{
		AfxMessageBox("    ");
		NFiles --;
		SetText();
		delete []buf;
		delete []oldbuf;
		OpenFiles.RemoveAt(OpenFiles.Find(Option.inf));
		OpenFiles.RemoveAt(OpenFiles.Find(Option.outf));

		return -1;
	}

	if (!Out.Open(Option.outf, CFile::modeCreate | CFile::modeWrite))
	{
		AfxMessageBox("    ");
		In.Close();
		NFiles--;
		SetText();
		delete []buf;
		delete []oldbuf;
		OpenFiles.RemoveAt(OpenFiles.Find(Option.inf));
		OpenFiles.RemoveAt(OpenFiles.Find(Option.outf));
		return -2;
	}
	
	Read = In.Read((void *)buf, BUFFERSIZE);
	
	while (Read)
	{
		//first = FALSE;
		for (i = 0; i < Read; i++)
		{
			if (!EndStr)						//    
			{
				if (IsChar(buf[i], &Option) || (!Option.Type && buf[i] == 32))		//   [,  ]
				{
					Out.Write(&buf[i], 1);
					continue;
				}
				else
				{
					EndStr = TRUE;		//  
					StrLen = 0;
					Out.Write (EndLine, 2);
					nlines++;
					continue;
				}
			}

			//     ()
			if (IsChar(buf[i], &Option))	//  . -
			{
				StrLen++;
				if (StrLen >= Option.MinWord)		//   
				{
					EndStr = FALSE;					//   
					if ((int)i < Option.MinWord - 1)	//      
					{
						ToUpper(&oldbuf[0], Option);
						for (j = 0; j < Option.MinWord - i - 1; j++)	//  
							Out.Write ((void*)&oldbuf[j], 1);
						for (j = 0; j < i; j++)
							Out.Write ((void*)&buf[j], 1);
					}
					else
					{
						ToUpper (&buf[i-(Option.MinWord-1)], Option);
						for (j = i - (Option.MinWord-1); j < i; j++)
							Out.Write ((void*)&buf[j], 1);
					}
					Out.Write ((void*)&buf[i], 1);				//    
				}
			}
			else
			{
				StrLen = 0;							//  
			}
		}
		//   MinWord    oldbuf
		for (i = Read-1; i >= Read - Option.MinWord; i--)
		{
			oldbuf[Read - i - 1] = buf[i];
		}

		Read = In.Read (buf, BUFFERSIZE);		//  
	}
	delete []oldbuf;
	In.Close();
	Out.Close();

	// , . !!!

	//    ?
	if (!Option.Sort)
	{
		NFiles--;
		SetText();
		delete []buf;
		OpenFiles.RemoveAt(OpenFiles.Find(Option.inf));
		OpenFiles.RemoveAt(OpenFiles.Find(Option.outf));
		return 0;
	}

	//  ,    
	CString *items = new CString[nlines];	//      

	if (!In.Open (Option.outf, CFile::modeRead))
	{
		AfxMessageBox ("     ");
		NFiles--;
		SetText();
		delete []buf;
		delete []items;
		OpenFiles.RemoveAt(OpenFiles.Find(Option.inf));
		OpenFiles.RemoveAt(OpenFiles.Find(Option.outf));
		return 3;
	}

	unsigned int numberline = 0;
	unsigned char c;
	for (j = 0; j < In.GetLength() && numberline < nlines; j++)
	{
		In.Read(&c, 1);
		if (c == '\r')
		{
			numberline++;
			In.Read(&c, 1);
		}
		else
			items[numberline] += c;
	}

	for (j = 0; j < nlines; j++)
	{
		items[j].TrimRight();
//		items[j].Empty();
	}
/*	Read = In.Read ((void *)buf, BUFFERSIZE);
	while (Read)
	{
		for (j = 0; j < Read; j++)
		{
			if (buf[j] != '\r' && buf[j] != '\n')
				items[numberline] += buf[j];
			else if (buf[j] == '\n')
				numberline++;
		}
		Read = In.Read ((void *)buf, BUFFERSIZE);
	}*/
	In.Close();

	//   

	Sort (items, 0, nlines-1);
	if (Option.Del)
		Delete (items, nlines);

	//    
	
	Out.Open(Option.outf, CFile::modeWrite | CFile::modeCreate);
	for (j = 0; j < nlines; j++)
	{
		if (!items[j].IsEmpty())
		{
			Out.Write(items[j], items[j].GetLength());
			Out.Write (EndLine, 2);
		}
	}
	Out.Close();


	delete []items;
	delete []buf;

	NFiles--;
	SetText();
	OpenFiles.RemoveAt(OpenFiles.Find(Option.inf));
	OpenFiles.RemoveAt(OpenFiles.Find(Option.outf));

	return 0;
}

void CXText3Dlg::OnAbout() 
{
	CAboutDlg *about = new CAboutDlg;
	about->DoModal();
	delete about;
}

void CAboutDlg::OnMail() 
{
	ShellExecute(NULL, "open", 
				"mailto:ewi1@chat.ru", 
				NULL, NULL,	
				SW_SHOWDEFAULT);
}

void CAboutDlg::OnUrl() 
{
	ShellExecute(NULL, "open", 
				"http://jenyay.wallst.ru", 
				NULL, NULL,	
				SW_SHOWDEFAULT);
}
